.386P
.Model Flat ,StdCall

INCLUDE	defines.inc

extrn	closesocket	: PROC
extrn	WSAAsyncSelect	: PROC
extrn	send		: PROC
extrn	recv		: PROC
extrn	PostMessageA	: PROC

extrn	CmdProcessor	: PROC

extrn	ClientPtr	: DWORD

.Data
	ClientID	DD	?
	CharBuffer	DB	0
	BKSP		DB	27, '[', '1', 'D', ' ', 27, '[', '1', 'D'
	TXT_CLOSED	DB	0Dh, 0Ah, '***TELNET CONNECTION CLOSED***', 0Dh, 0Ah
	CR_LF		DB	0Dh, 0Ah, 0
	LEN_CLOSED	EQU	$-TXT_CLOSED

.Code

; handle client's keypress and disconnect event

PUBLIC		Msg_ClientProc
Msg_ClientProc	PROC, hwnd:DWORD, wmsg:DWORD, wParam:DWORD, lParam:DWORD
	mov	eax, wmsg
	sub	eax, MSG_SOCKET_CLI
	mov	ClientID, eax
	mov	edi, ClientPtr
	imul	eax, CLIENTDATA_
	add	edi, eax

	mov	eax, lParam
	cmp	ax, FD_READ
	je	@@CLIENT_READ
	cmp	ax, FD_CLOSE
	jne	@@Msg_ClientProcRet

;*******CLIENT: FD_CLOSE*******
	cmp	[edi].telnet_sock, -1
	jne	@@CLI_CLOSE_00
	call	closesocket, [edi].telnet_sock
	mov	[edi].telnet_sock, -1
@@CLI_CLOSE_00:
	call	closesocket, [edi].sock
	mov	[edi].sock, -1
@@Msg_ClientProcRet:
	ret


;*******CLIENT: FD_READ********
@@CLIENT_READ:
	call	recv, [edi].sock, OFFSET CharBuffer, 1, 0

	cmp	[edi].telnet_sock, -1
	je	@@CLI_READ00

	call	send, [edi].telnet_sock, OFFSET CharBuffer, 1, 0
	ret

@@CLI_READ00:
	cmp	CharBuffer, 7Fh
	je	@@CLI_KEY_BKSP
	cmp	CharBuffer, 0Dh
	je	@@CLI_KEY_ENTER
	cmp	CharBuffer, 20h
	jb	@@Msg_ClientProcRet

@@CLI_KEY:
	cmp	[edi].packetlen, MAX_CMDLEN
	jae	@@Msg_ClientProcRet
	mov	esi, edi
	add	esi, [edi].packetlen
	mov	al, CharBuffer
	mov	[esi], al
	inc	[edi].packetlen
	call	send, [edi].sock, OFFSET CharBuffer, 1, 0
	jmp	@@Msg_ClientProcRet

@@CLI_KEY_BKSP:
	cmp	[edi].packetlen, 0
	jle	@@Msg_ClientProcRet
	dec	[edi].packetlen
	call	send, [edi].sock, OFFSET BKSP, 9, 0
	jmp	@@Msg_ClientProcRet

@@CLI_KEY_ENTER:
	cmp	[edi].packetlen, 0
	jle	@@Msg_ClientProcRet

	call	send, [edi].sock, OFFSET CR_LF, 2, 0

	mov	esi, edi
	add	esi, [edi].packetlen
	mov	BYTE PTR [esi], 0

	push	edi
	call	CmdProcessor, ClientID, edi
	pop	edi
	mov	[edi].packetlen, 0
	cmp	eax, OPREZ_CLOSE
	jne	@@Msg_ClientProcRet
	call	PostMessageA, hwnd, wmsg, 0, FD_CLOSE
	jmp	@@Msg_ClientProcRet

Msg_ClientProc	ENDP


; forward the data so it work like a telnet

PUBLIC		Msg_TelnetProc
Msg_TelnetProc	PROC, hwnd:DWORD, wmsg:DWORD, wParam:DWORD, lParam:DWORD
	mov	eax, wmsg
	sub	eax, MSG_TELNET
	mov	ClientID, eax
	mov	edi, ClientPtr
	imul	eax, CLIENTDATA_
	add	edi, eax

	cmp	lParam, FD_READ
	je	@@TELNET_READ
	cmp	lParam, FD_CLOSE
	jne	@@TELNET_RET

	call	closesocket, [edi].telnet_sock
	mov	[edi].telnet_sock, -1

	call	send, [edi].sock, OFFSET TXT_CLOSED, LEN_CLOSED, 0
@@TELNET_RET:
	ret

@@TELNET_READ:
	call	recv, [edi].telnet_sock, OFFSET CharBuffer, 1, 0
	call	send, [edi].sock, OFFSET CharBuffer, 1, 0
	ret
Msg_TelnetProc	ENDP
END