.386P
.Model Flat ,StdCall

INCLUDE defines.inc

WINDOW_WIDTH	EQU	400
WINDOW_HEIGHT	EQU	300

COLOR_WINDOW		EQU	5
IDC_ARROW		EQU	32512
WS_VISIBLE		EQU	10000000h
WS_POPUP		EQU	80000000h
WS_OVERLAPPEDWINDOW	EQU	00CC0000h

extrn	MessageBoxA	: PROC
extrn	GetModuleHandleA: PROC
extrn	RegisterClassA	: PROC
extrn	CreateWindowExA	: PROC
extrn	GetMessageA	: PROC
extrn	TranslateMessage: PROC
extrn	DispatchMessageA: PROC
extrn	PostQuitMessage	: PROC
extrn	ExitProcess	: PROC
extrn	WndProc		: PROC

extrn	InitMemMgr	: PROC
extrn	DeInitMemMgr	: PROC
extrn	SocketStart	: PROC
extrn	SetSocketHandler: PROC

WNDCLASS		struct
	wc_style		dd	0
	wc_lpfnWndProc		dd	0
	wc_cbClsExtra		dd	0
	wc_cbWndExtra		dd	0
	wc_hInstance		dd	0
	wc_hIcon		dd	0
	wc_hCursor		dd	0
	wc_hbrBackground	dd	0
	wc_lpszMenuName		dd	0
	wc_lpszClassName	dd	0
WNDCLASS		ends

MSG			struct
	ms_hwnd		dd	0
	ms_message	dd	0
	ms_wParam	dd	0
	ms_lParam	dd	0
	ms_time		dd	0
	ms_x		dd	0
	ms_y		dd	0
MSG			ends

.Data
	WINDOW_NAME	DB		'kernel32', 0
	hInst		DD		?
	MainWnd		DD		?

	the_msg		LABEL		MSG
	wc		WNDCLASS	?

PUBLIC	MainWnd

.Code

PUBLIC Startup
Startup:
winmain		PROC
	call	CreateTheWindow

	call	InitMemMgr
	or	eax, eax
	jz	end_loop
	call	SocketStart
	jnz	end_loop
	mov	eax, MainWnd
	call	SetSocketHandler
	or	eax, eax
	jz	msg_loop
	call	PostQuitMessage, 0
msg_loop:
	call	GetMessageA, OFFSET the_msg, NULL, 0, 0
	or	eax, eax
	jz	end_loop
	call	TranslateMessage, OFFSET the_msg
	call	DispatchMessageA, OFFSET the_msg
	jmp	msg_loop
end_loop:
	call	DeInitMemMgr
	call	ExitProcess, 0
winmain		ENDP


CreateTheWindow		PROC
	call	GetModuleHandleA, NULL
	mov	hInst, eax

	mov	wc.wc_hInstance, eax
	xor	eax, eax
	mov	wc.wc_hbrBackground, COLOR_WINDOW
	mov	wc.wc_style, eax
	mov	wc.wc_lpszMenuName, eax
	mov	wc.wc_cbClsExtra, eax
	mov	wc.wc_cbWndExtra, eax
	mov	wc.wc_hIcon, eax
	mov	wc.wc_hCursor, eax
	mov	wc.wc_lpszClassName, OFFSET WINDOW_NAME
	mov	wc.wc_lpfnWndProc, OFFSET WndProc

	call    RegisterClassA, OFFSET wc

	push	0
	push	hInst
	push	0
	push	0
	push	WINDOW_HEIGHT
	push	WINDOW_WIDTH
	push	0
	push	0
	push	WS_POPUP	; + WS_VISIBLE
	push	OFFSET WINDOW_NAME
	push	OFFSET WINDOW_NAME
	push	0
	call    CreateWindowExA
	mov	MainWnd, eax
	ret
CreateTheWindow		ENDP

End winmain
